package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Model base information list, include Model type information and currentVersion list
 */
@ApiModel(description = "Model base information list, include Model type information and currentVersion list")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class ModelBaseInfo   {
  @JsonProperty("modelTypeInfo")
  private ModelTypeInfoOpenApiVo modelTypeInfo;

  @JsonProperty("currentVersion")
  @Valid
  private List<String> currentVersion = null;

  public ModelBaseInfo modelTypeInfo(ModelTypeInfoOpenApiVo modelTypeInfo) {
    this.modelTypeInfo = modelTypeInfo;
    return this;
  }

  /**
   * Get modelTypeInfo
   * @return modelTypeInfo
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull

  @Valid

  public ModelTypeInfoOpenApiVo getModelTypeInfo() {
    return modelTypeInfo;
  }

  public void setModelTypeInfo(ModelTypeInfoOpenApiVo modelTypeInfo) {
    this.modelTypeInfo = modelTypeInfo;
  }

  public ModelBaseInfo currentVersion(List<String> currentVersion) {
    this.currentVersion = currentVersion;
    return this;
  }

  public ModelBaseInfo addCurrentVersionItem(String currentVersionItem) {
    if (this.currentVersion == null) {
      this.currentVersion = new ArrayList<>();
    }
    this.currentVersion.add(currentVersionItem);
    return this;
  }

  /**
   * Model version list, software version, such as \"2.5.0 Build 20190118 Rel. 64821\".
   * @return currentVersion
  */
  @ApiModelProperty(value = "Model version list, software version, such as \"2.5.0 Build 20190118 Rel. 64821\".")


  public List<String> getCurrentVersion() {
    return currentVersion;
  }

  public void setCurrentVersion(List<String> currentVersion) {
    this.currentVersion = currentVersion;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ModelBaseInfo modelBaseInfo = (ModelBaseInfo) o;
    return Objects.equals(this.modelTypeInfo, modelBaseInfo.modelTypeInfo) &&
        Objects.equals(this.currentVersion, modelBaseInfo.currentVersion);
  }

  @Override
  public int hashCode() {
    return Objects.hash(modelTypeInfo, currentVersion);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ModelBaseInfo {\n");
    
    sb.append("    modelTypeInfo: ").append(toIndentedString(modelTypeInfo)).append("\n");
    sb.append("    currentVersion: ").append(toIndentedString(currentVersion)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

